upsampleFactor = 4;

% ####### Load .wav
[y, Fs, nbits] = wavread('Audio.wav');
disp(['.wav file sample rate: ', num2str(Fs)]);
disp(['Original length: ', num2str(length(y))]);
chan1 = y(:, 1);
chan2 = y(:, 2);

% ####### convert column vectors to row vector
chan1 = chan1.';
chan2 = chan2.';

% ####### upsample via FFT zero insertion
chan1FFTUs = FFT_upsample(chan1, upsampleFactor);
% chan2FFTUs = FFT_upsample(chan2, upsampleFactor);

% ####### upsample via FIR interpolation
% ####### zero insertion
chan1 = upsample(chan1, upsampleFactor);

%interp_filter() generated via FDATool export
h1 = interp_filter();
[gd, w] = grpdelay(h1);
gd = mean(gd);
[chan1FirUs, chan1FirUsTail] = filter(h1, 1, chan1);
chan1FirUs = [chan1FirUs, chan1FirUsTail.'];
chan1FirUs = upsampleFactor * chan1FirUs(gd + (1:length(chan1)));

%chan2 = upsample(chan2, upsampleFactor);
% disp(['Upsampled length: ', num2str(length(chan1))]);

% ######## plot comparison time-domain graphs
%start
numSamples = 1000000;
start = 1;
finish = numSamples;
subplot(3,1,1), plot(chan1(start:finish), 'c*');
hold on
plot([start:finish], chan1FFTUs(start:finish), 'g');
plot([start:finish], chan1FirUs(start:finish), 'r');
hold off

% middle 
numSamples = 1000000;
start = length(chan1) / 2 - numSamples / 2 + 1;
finish = length(chan1) / 2 - numSamples / 2 + numSamples;
subplot(3,1,2), plot(chan1(start:finish), 'c*');
hold on
plot(chan1FFTUs(start:finish), 'g');
plot(chan1FirUs(start:finish), 'r');
hold off

% end 
numSamples = 1000000;
start = length(chan1) - numSamples + 1;
finish = length(chan1);
subplot(3,1,3), 
plot(chan1(start:finish), 'c*');
hold on
plot(chan1FFTUs(start:finish), 'g');
plot(chan1FirUs(start:finish), 'r');
hold off

% ######## output upsampled .wav file. Uncomment if required.
% work for wavwrite function
% chan1FFTUs = chan1FFTUs.';
% chan2FFTUs = chan2FFTUs.';
% outputAudio = [chan1FFTUs, chan2FFTUs];
% scale values between -1 and +1
% maxValue = max(max(abs(outputAudio)));
% outputAudio = outputAudio / maxValue;
% audiowrite('AudioFFTUs.wav', outputAudio, Fs * upsampleFactor, 'BitsPerSample', nbits);

